#!/bin/sh
#-*-mode:  sh -*-

# Copyright (c) 2017, Aleksey Cheusov <vle@gmx.net>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

set -e

export LC_ALL=C

############################################################

LIBEXECDIR=${LIBEXECDIR-/usr/pkg/libexec/psu}
. ${LIBEXECDIR}/sig_handler.sh
on_exit () {
	# Stupid test for stupid Solaris
	if test -n "$tmp_dir"; then rm -rf $tmp_dir; fi
}

tmp_dir=`mktemp -d ${TMPDIR-/tmp}/pkg_cleanup_dir.XXXXXX`
test -n "$tmp_dir" || exit 1

############################################################

usage (){
    cat 1>&2 <<EOF
pkg_cleanup_dir - analyses FIELD in package summary given on input
and optionally removes files and directories under DIR,
not referenced by any package. FIELD may be FILE_NAME, for example.
Also, FILES are not removed.

usage: pkg_cleanup_dir [OPTIONS] [files...]
OPTIONS:
  -h            display this help message
  -r            remove unreferenced files and empty directories
  -d <DIR>      directory to clean up (mandatory option)
  -f <FIELD>    field name (mandatory option)
  -x <FILES>    do not remove the specified files
  -s            DIR is set as dirname of pkg_summary file
  -I            ignore subdirectry of files under DIR
  -D            do not remove empty sudirectories
EOF
}

delete=''
while getopts d:DIf:hrsx: f; do
    case "$f" in
	h)   usage; exit 0;;
	r)   delete=1;;
	d)   dir="$OPTARG";;
	f)   field="$OPTARG";;
	s)   dirname_cnt="$dirname_cnt x";;
	x)   ex_files="$OPTARG";;
	I)   ign_subdir=1;;
	D)   keep_empty_dirs=1;;
	?)   printf "Run pkg_cleanup_dir -h for details\n"; exit 2;;
    esac
done
shift `expr $OPTIND - 1`

if test -n "$dirname_cnt"; then
    if test $# -eq 0; then
	echo "Missing pkg_summary" 1>&2
	usage
	exit 1
    else
	dir="$1"
	for i in $dirname_cnt; do
	    dir=`dirname "$dir"`
	done
    fi
fi

if test -z "$dir"; then
    echo "Directory to clean-up was not specified" 1>&2
    usage
    exit 1
fi

if test -z "$field"; then
    echo "Field name was not specified" 1>&2
    usage
    exit 1
fi

useful_files (){
    runawk -v field="$field" -v ex_files="$ex_files" -e \
    '
    BEGIN {
	split(ex_files, arr)
	for (i in arr)
	    print arr[i]
    }
    match($0, /^[^=]*=/) > 0 && substr($0, RSTART, RLENGTH-1) == field {
	$0 = substr($0, RLENGTH+1)
	for (i=1; i <= NF; ++i)
	    print $i
    }' "$@" |
    sort | uniq
}

existing_files (){
    find . -type f | sed 's,^[.]/,,'
}

ex_file=$tmp_dir/existing
us_file=$tmp_dir/useful
rm_file=$tmp_dir/to_be_removed
rmdir_file=$tmp_dir/dirs

useful_files "$@" > "$us_file"

cd "$dir"
existing_files > "$ex_file"

runawk -v ign_subdir="$ign_subdir" -f basename.awk -e '
FILENAME ~ /useful$/ {
    useful[$0] = 1; next
}
{
    fn = $0
    if (ign_subdir) fn = basename(fn)
    if (! (fn in useful)) print $0
}
' "$us_file" "$ex_file" > "$rm_file"

if test -n "$delete"; then
    xargs rm -f < "$rm_file"

    if test -z "$keep_empty_dirs"; then
	sed 's,/[^/]*$,,' "$rm_file" | sort | uniq |
	while read -r dir; do
	    while test "$dir" != '.'; do
		if ! rmdir "$dir" 2>/dev/null; then
		    break
		fi
		dir=`dirname $dir`
	    done
	done
    fi
else
    cat "$rm_file"
fi
